diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index c3937a60fd..837dc6b20d 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -1348,7 +1348,7 @@ pg_get_indexdef_worker(Oid indexrelid, int colno,
 	sep = "";
 	for (keyno = 0; keyno < idxrec->indnatts; keyno++)
 	{
-		AttrNumber	attnum = idxrec->indkey.values[keyno];
+		AttrNumber	attphysnum = idxrec->indkey.values[keyno];
 		Oid			keycoltype;
 		Oid			keycolcollation;
 
@@ -1369,16 +1369,16 @@ pg_get_indexdef_worker(Oid indexrelid, int colno,
 			appendStringInfoString(&buf, sep);
 		sep = ", ";
 
-		if (attnum != 0)
+		if (attphysnum != 0)
 		{
 			/* Simple index column */
 			char	   *attname;
 			int32		keycoltypmod;
 
-			attname = get_attname(indrelid, attnum, false);
+			attname = get_attname(indrelid, attphysnum, false);
 			if (!colno || colno == keyno + 1)
 				appendStringInfoString(&buf, quote_identifier(attname));
-			get_atttypetypmodcoll(indrelid, attnum,
+			get_atttypetypmodcoll(indrelid, attphysnum,
 								  &keycoltype, &keycoltypmod,
 								  &keycolcollation);
 		}
@@ -1744,13 +1744,13 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 	/* decode simple column references */
 	for (colno = 0; colno < statextrec->stxkeys.dim1; colno++)
 	{
-		AttrNumber	attnum = statextrec->stxkeys.values[colno];
+		AttrNumber	attphysnum = statextrec->stxkeys.values[colno];
 		char	   *attname;
 
 		if (colno > 0)
 			appendStringInfoString(&buf, ", ");
 
-		attname = get_attname(statextrec->stxrelid, attnum, false);
+		attname = get_attname(statextrec->stxrelid, attphysnum, false);
 
 		appendStringInfoString(&buf, quote_identifier(attname));
 	}
@@ -1990,22 +1990,22 @@ pg_get_partkeydef_worker(Oid relid, int prettyFlags,
 	sep = "";
 	for (keyno = 0; keyno < form->partnatts; keyno++)
 	{
-		AttrNumber	attnum = form->partattrs.values[keyno];
+		AttrNumber	attphysnum = form->partattrs.values[keyno];
 		Oid			keycoltype;
 		Oid			keycolcollation;
 		Oid			partcoll;
 
 		appendStringInfoString(&buf, sep);
 		sep = ", ";
-		if (attnum != 0)
+		if (attphysnum != 0)
 		{
 			/* Simple attribute reference */
 			char	   *attname;
 			int32		keycoltypmod;
 
-			attname = get_attname(relid, attnum, false);
+			attname = get_attname(relid, attphysnum, false);
 			appendStringInfoString(&buf, quote_identifier(attname));
-			get_atttypetypmodcoll(relid, attnum,
+			get_atttypetypmodcoll(relid, attphysnum,
 								  &keycoltype, &keycoltypmod,
 								  &keycolcollation);
 		}
@@ -2798,7 +2798,7 @@ pg_get_serial_sequence(PG_FUNCTION_ARGS)
 	RangeVar   *tablerv;
 	Oid			tableOid;
 	char	   *column;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	Oid			sequenceId = InvalidOid;
 	Relation	depRel;
 	ScanKeyData key[3];
@@ -2812,8 +2812,8 @@ pg_get_serial_sequence(PG_FUNCTION_ARGS)
 	/* Get the number of the column */
 	column = text_to_cstring(columnname);
 
-	attnum = get_attnum(tableOid, column);
-	if (attnum == InvalidAttrNumber)
+	attphysnum = get_attphysnum(tableOid, column);
+	if (attphysnum == InvalidAttrNumber)
 		ereport(ERROR,
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
@@ -2833,7 +2833,7 @@ pg_get_serial_sequence(PG_FUNCTION_ARGS)
 	ScanKeyInit(&key[2],
 				Anum_pg_depend_refobjsubid,
 				BTEqualStrategyNumber, F_INT4EQ,
-				Int32GetDatum(attnum));
+				Int32GetDatum(attphysnum));
 
 	scan = systable_beginscan(depRel, DependReferenceIndexId, true,
 							  NULL, 3, key);
@@ -4595,7 +4595,7 @@ set_join_column_names(deparse_namespace *dpns, RangeTblEntry *rte,
 	 * added since parse time must be inserted in the right places.  This code
 	 * must match the parser, which will order a join's columns as merged
 	 * columns first (in USING-clause order), then non-merged columns from the
-	 * left input (in attnum order), then non-merged columns from the right
+	 * left input (in attphysnum order), then non-merged columns from the right
 	 * input (ditto).  If one of the inputs is itself a join, its columns will
 	 * be ordered according to the same rule, which means newly-added columns
 	 * might not be at the end.  We can figure out what's what by consulting
@@ -7118,7 +7118,7 @@ get_variable(Var *var, int levelsup, bool istoplevel, deparse_context *context)
 {
 	StringInfo	buf = context->buf;
 	RangeTblEntry *rte;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	int			netlevelsup;
 	deparse_namespace *dpns;
 	int			varno;
@@ -7209,7 +7209,7 @@ get_variable(Var *var, int levelsup, bool istoplevel, deparse_context *context)
 		rte = rt_fetch(varno, dpns->rtable);
 		refname = (char *) list_nth(dpns->rtable_names, varno - 1);
 		colinfo = deparse_columns_fetch(varno, dpns);
-		attnum = varattno;
+		attphysnum = varattno;
 	}
 	else
 	{
@@ -7230,16 +7230,16 @@ get_variable(Var *var, int levelsup, bool istoplevel, deparse_context *context)
 	 * we'll have set dpns->inner_plan to reference the child plan node.
 	 */
 	if ((rte->rtekind == RTE_SUBQUERY || rte->rtekind == RTE_CTE) &&
-		attnum > list_length(rte->eref->colnames) &&
+		attphysnum > list_length(rte->eref->colnames) &&
 		dpns->inner_plan)
 	{
 		TargetEntry *tle;
 		deparse_namespace save_dpns;
 
-		tle = get_tle_by_resno(dpns->inner_tlist, attnum);
+		tle = get_tle_by_resno(dpns->inner_tlist, attphysnum);
 		if (!tle)
-			elog(ERROR, "invalid attnum %d for relation \"%s\"",
-				 attnum, rte->eref->aliasname);
+			elog(ERROR, "invalid attphysnum %d for relation \"%s\"",
+				 attphysnum, rte->eref->aliasname);
 
 		Assert(netlevelsup == 0);
 		push_child_plan(dpns, dpns->inner_plan, &save_dpns);
@@ -7274,11 +7274,11 @@ get_variable(Var *var, int levelsup, bool istoplevel, deparse_context *context)
 	{
 		if (rte->joinaliasvars == NIL)
 			elog(ERROR, "cannot decompile join alias var in plan tree");
-		if (attnum > 0)
+		if (attphysnum > 0)
 		{
 			Var		   *aliasvar;
 
-			aliasvar = (Var *) list_nth(rte->joinaliasvars, attnum - 1);
+			aliasvar = (Var *) list_nth(rte->joinaliasvars, attphysnum - 1);
 			/* we intentionally don't strip implicit coercions here */
 			if (aliasvar && IsA(aliasvar, Var))
 			{
@@ -7295,23 +7295,23 @@ get_variable(Var *var, int levelsup, bool istoplevel, deparse_context *context)
 		Assert(refname == NULL);
 	}
 
-	if (attnum == InvalidAttrNumber)
+	if (attphysnum == InvalidAttrNumber)
 		attname = NULL;
-	else if (attnum > 0)
+	else if (attphysnum > 0)
 	{
 		/* Get column name to use from the colinfo struct */
-		if (attnum > colinfo->num_cols)
-			elog(ERROR, "invalid attnum %d for relation \"%s\"",
-				 attnum, rte->eref->aliasname);
-		attname = colinfo->colnames[attnum - 1];
+		if (attphysnum > colinfo->num_cols)
+			elog(ERROR, "invalid attphysnum %d for relation \"%s\"",
+				 attphysnum, rte->eref->aliasname);
+		attname = colinfo->colnames[attphysnum - 1];
 		if (attname == NULL)	/* dropped column? */
-			elog(ERROR, "invalid attnum %d for relation \"%s\"",
-				 attnum, rte->eref->aliasname);
+			elog(ERROR, "invalid attphysnum %d for relation \"%s\"",
+				 attphysnum, rte->eref->aliasname);
 	}
 	else
 	{
 		/* System column - name is fixed, get it from the catalog */
-		attname = get_rte_attribute_name(rte, attnum);
+		attname = get_rte_attribute_name(rte, attphysnum);
 	}
 
 	if (refname && (context->varprefix || attname == NULL))
@@ -7474,7 +7474,7 @@ get_name_for_var_field(Var *var, int fieldno,
 					   int levelsup, deparse_context *context)
 {
 	RangeTblEntry *rte;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	int			netlevelsup;
 	deparse_namespace *dpns;
 	int			varno;
@@ -7566,7 +7566,7 @@ get_name_for_var_field(Var *var, int fieldno,
 	if (varno >= 1 && varno <= list_length(dpns->rtable))
 	{
 		rte = rt_fetch(varno, dpns->rtable);
-		attnum = varattno;
+		attphysnum = varattno;
 	}
 	else if (varno == OUTER_VAR && dpns->outer_tlist)
 	{
@@ -7628,7 +7628,7 @@ get_name_for_var_field(Var *var, int fieldno,
 		return NULL;			/* keep compiler quiet */
 	}
 
-	if (attnum == InvalidAttrNumber)
+	if (attphysnum == InvalidAttrNumber)
 	{
 		/* Var is whole-row reference to RTE, so select the right field */
 		return get_rte_attribute_name(rte, fieldno);
@@ -7662,11 +7662,11 @@ get_name_for_var_field(Var *var, int fieldno,
 				if (rte->subquery)
 				{
 					TargetEntry *ste = get_tle_by_resno(rte->subquery->targetList,
-														attnum);
+														attphysnum);
 
 					if (ste == NULL || ste->resjunk)
 						elog(ERROR, "subquery %s does not have attribute %d",
-							 rte->eref->aliasname, attnum);
+							 rte->eref->aliasname, attphysnum);
 					expr = (Node *) ste->expr;
 					if (IsA(expr, Var))
 					{
@@ -7711,10 +7711,10 @@ get_name_for_var_field(Var *var, int fieldno,
 					if (!dpns->inner_plan)
 						elog(ERROR, "failed to find plan for subquery %s",
 							 rte->eref->aliasname);
-					tle = get_tle_by_resno(dpns->inner_tlist, attnum);
+					tle = get_tle_by_resno(dpns->inner_tlist, attphysnum);
 					if (!tle)
 						elog(ERROR, "bogus varattno for subquery var: %d",
-							 attnum);
+							 attphysnum);
 					Assert(netlevelsup == 0);
 					push_child_plan(dpns, dpns->inner_plan, &save_dpns);
 
@@ -7730,8 +7730,8 @@ get_name_for_var_field(Var *var, int fieldno,
 			/* Join RTE --- recursively inspect the alias variable */
 			if (rte->joinaliasvars == NIL)
 				elog(ERROR, "cannot decompile join alias var in plan tree");
-			Assert(attnum > 0 && attnum <= list_length(rte->joinaliasvars));
-			expr = (Node *) list_nth(rte->joinaliasvars, attnum - 1);
+			Assert(attphysnum > 0 && attphysnum <= list_length(rte->joinaliasvars));
+			expr = (Node *) list_nth(rte->joinaliasvars, attphysnum - 1);
 			Assert(expr != NULL);
 			/* we intentionally don't strip implicit coercions here */
 			if (IsA(expr, Var))
@@ -7778,11 +7778,11 @@ get_name_for_var_field(Var *var, int fieldno,
 				{
 					Query	   *ctequery = (Query *) cte->ctequery;
 					TargetEntry *ste = get_tle_by_resno(GetCTETargetList(cte),
-														attnum);
+														attphysnum);
 
 					if (ste == NULL || ste->resjunk)
 						elog(ERROR, "subquery %s does not have attribute %d",
-							 rte->eref->aliasname, attnum);
+							 rte->eref->aliasname, attphysnum);
 					expr = (Node *) ste->expr;
 					if (IsA(expr, Var))
 					{
@@ -7832,10 +7832,10 @@ get_name_for_var_field(Var *var, int fieldno,
 					if (!dpns->inner_plan)
 						elog(ERROR, "failed to find plan for CTE %s",
 							 rte->eref->aliasname);
-					tle = get_tle_by_resno(dpns->inner_tlist, attnum);
+					tle = get_tle_by_resno(dpns->inner_tlist, attphysnum);
 					if (!tle)
 						elog(ERROR, "bogus varattno for subquery var: %d",
-							 attnum);
+							 attphysnum);
 					Assert(netlevelsup == 0);
 					push_child_plan(dpns, dpns->inner_plan, &save_dpns);
 
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index fa1f589fad..04702b3ccc 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -3973,24 +3973,24 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 		{
 			ListCell   *lc3;
 			GroupVarInfo *varinfo = (GroupVarInfo *) lfirst(lc2);
-			AttrNumber	attnum;
+			AttrNumber	attphysnum;
 
 			Assert(varinfo->rel == rel);
 
 			/* simple Var, search in statistics keys directly */
 			if (IsA(varinfo->var, Var))
 			{
-				attnum = ((Var *) varinfo->var)->varattno;
+				attphysnum = ((Var *) varinfo->var)->varattno;
 
 				/*
 				 * Ignore system attributes - we don't support statistics on
 				 * them, so can't match them (and it'd fail as the values are
 				 * negative).
 				 */
-				if (!AttrNumberIsForUserDefinedAttr(attnum))
+				if (!AttrNumberIsForUserDefinedAttr(attphysnum))
 					continue;
 
-				if (bms_is_member(attnum, info->keys))
+				if (bms_is_member(attphysnum, info->keys))
 					nshared_vars++;
 
 				continue;
@@ -4077,25 +4077,25 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 			 */
 			if (IsA(varinfo->var, Var))
 			{
-				AttrNumber	attnum = ((Var *) varinfo->var)->varattno;
+				AttrNumber	attphysnum = ((Var *) varinfo->var)->varattno;
 
 				/*
 				 * Ignore expressions on system attributes. Can't rely on the
 				 * bms check for negative values.
 				 */
-				if (!AttrNumberIsForUserDefinedAttr(attnum))
+				if (!AttrNumberIsForUserDefinedAttr(attphysnum))
 					continue;
 
 				/* Is the variable covered by the statistics object? */
-				if (!bms_is_member(attnum, matched_info->keys))
+				if (!bms_is_member(attphysnum, matched_info->keys))
 					continue;
 
-				attnum = attnum + attnum_offset;
+				attphysnum = attphysnum + attnum_offset;
 
 				/* ensure sufficient offset */
-				Assert(AttrNumberIsForUserDefinedAttr(attnum));
+				Assert(AttrNumberIsForUserDefinedAttr(attphysnum));
 
-				matched = bms_add_member(matched, attnum);
+				matched = bms_add_member(matched, attphysnum);
 
 				found = true;
 			}
@@ -4116,14 +4116,14 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 
 				if (equal(varinfo->var, expr))
 				{
-					AttrNumber	attnum = -(idx + 1);
+					AttrNumber	attphysnum = -(idx + 1);
 
-					attnum = attnum + attnum_offset;
+					attphysnum = attphysnum + attnum_offset;
 
 					/* ensure sufficient offset */
-					Assert(AttrNumberIsForUserDefinedAttr(attnum));
+					Assert(AttrNumberIsForUserDefinedAttr(attphysnum));
 
-					matched = bms_add_member(matched, attnum);
+					matched = bms_add_member(matched, attphysnum);
 
 					/* there should be just one matching expression */
 					break;
@@ -4148,15 +4148,15 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 			/* check that all item attributes/expressions fit the match */
 			for (j = 0; j < tmpitem->nattributes; j++)
 			{
-				AttrNumber	attnum = tmpitem->attributes[j];
+				AttrNumber	attphysnum = tmpitem->attributes[j];
 
 				/*
 				 * Thanks to how we constructed the matched bitmap above, we
 				 * can just offset all attnums the same way.
 				 */
-				attnum = attnum + attnum_offset;
+				attphysnum = attphysnum + attnum_offset;
 
-				if (!bms_is_member(attnum, matched))
+				if (!bms_is_member(attphysnum, matched))
 				{
 					/* nah, it's not this item */
 					item = NULL;
@@ -4189,28 +4189,28 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 			/*
 			 * Let's look at plain variables first, because it's the most
 			 * common case and the check is quite cheap. We can simply get the
-			 * attnum and check (with an offset) matched bitmap.
+			 * attphysnum and check (with an offset) matched bitmap.
 			 */
 			if (IsA(varinfo->var, Var))
 			{
-				AttrNumber	attnum = ((Var *) varinfo->var)->varattno;
+				AttrNumber	attphysnum = ((Var *) varinfo->var)->varattno;
 
 				/*
 				 * If it's a system attribute, we're done. We don't support
 				 * extended statistics on system attributes, so it's clearly
 				 * not matched. Just keep the expression and continue.
 				 */
-				if (!AttrNumberIsForUserDefinedAttr(attnum))
+				if (!AttrNumberIsForUserDefinedAttr(attphysnum))
 				{
 					newlist = lappend(newlist, varinfo);
 					continue;
 				}
 
 				/* apply the same offset as above */
-				attnum += attnum_offset;
+				attphysnum += attnum_offset;
 
 				/* if it's not matched, keep the varinfo */
-				if (!bms_is_member(attnum, matched))
+				if (!bms_is_member(attphysnum, matched))
 					newlist = lappend(newlist, varinfo);
 
 				/* The rest of the loop deals with complex expressions. */
@@ -7804,14 +7804,14 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	foreach(l, path->indexclauses)
 	{
 		IndexClause *iclause = lfirst_node(IndexClause, l);
-		AttrNumber	attnum = index->indexkeys[iclause->indexcol];
+		AttrNumber	attphysnum = index->indexkeys[iclause->indexcol];
 
 		/* attempt to lookup stats in relation for this index column */
-		if (attnum != 0)
+		if (attphysnum != 0)
 		{
 			/* Simple variable -- look to stats for the underlying table */
 			if (get_relation_stats_hook &&
-				(*get_relation_stats_hook) (root, rte, attnum, &vardata))
+				(*get_relation_stats_hook) (root, rte, attphysnum, &vardata))
 			{
 				/*
 				 * The hook took control of acquiring a stats tuple.  If it
@@ -7826,7 +7826,7 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 				vardata.statsTuple =
 					SearchSysCache3(STATRELATTINH,
 									ObjectIdGetDatum(rte->relid),
-									Int16GetDatum(attnum),
+									Int16GetDatum(attphysnum),
 									BoolGetDatum(false));
 				vardata.freefunc = ReleaseSysCache;
 			}
@@ -7838,11 +7838,11 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 			 * see if there's any stats for it.
 			 */
 
-			/* get the attnum from the 0-based index. */
-			attnum = iclause->indexcol + 1;
+			/* get the attphysnum from the 0-based index. */
+			attphysnum = iclause->indexcol + 1;
 
 			if (get_index_stats_hook &&
-				(*get_index_stats_hook) (root, index->indexoid, attnum, &vardata))
+				(*get_index_stats_hook) (root, index->indexoid, attphysnum, &vardata))
 			{
 				/*
 				 * The hook took control of acquiring a stats tuple.  If it
@@ -7856,7 +7856,7 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 			{
 				vardata.statsTuple = SearchSysCache3(STATRELATTINH,
 													 ObjectIdGetDatum(index->indexoid),
-													 Int16GetDatum(attnum),
+													 Int16GetDatum(attphysnum),
 													 BoolGetDatum(false));
 				vardata.freefunc = ReleaseSysCache;
 			}
diff --git a/src/backend/utils/cache/attoptcache.c b/src/backend/utils/cache/attoptcache.c
index 9e252a0891..0c9893ca95 100644
--- a/src/backend/utils/cache/attoptcache.c
+++ b/src/backend/utils/cache/attoptcache.c
@@ -27,11 +27,11 @@
 /* Hash table for information about each attribute's options */
 static HTAB *AttoptCacheHash = NULL;
 
-/* attrelid and attnum form the lookup key, and must appear first */
+/* attrelid and attphysnum form the lookup key, and must appear first */
 typedef struct
 {
 	Oid			attrelid;
-	int			attnum;
+	int			attphysnum;
 } AttoptCacheKey;
 
 typedef struct
@@ -90,7 +90,7 @@ InitializeAttoptCache(void)
 		CreateCacheMemoryContext();
 
 	/* Watch for invalidation events. */
-	CacheRegisterSyscacheCallback(ATTNUM,
+	CacheRegisterSyscacheCallback(ATTPHYSNUM,
 								  InvalidateAttoptCacheCallback,
 								  (Datum) 0);
 }
@@ -100,7 +100,7 @@ InitializeAttoptCache(void)
  *		Fetch attribute options for a specified table OID.
  */
 AttributeOpts *
-get_attribute_options(Oid attrelid, int attnum)
+get_attribute_options(Oid attrelid, int attphysnum)
 {
 	AttoptCacheKey key;
 	AttoptCacheEntry *attopt;
@@ -112,7 +112,7 @@ get_attribute_options(Oid attrelid, int attnum)
 		InitializeAttoptCache();
 	memset(&key, 0, sizeof(key));	/* make sure any padding bits are unset */
 	key.attrelid = attrelid;
-	key.attnum = attnum;
+	key.attphysnum = attphysnum;
 	attopt =
 		(AttoptCacheEntry *) hash_search(AttoptCacheHash,
 										 (void *) &key,
@@ -124,9 +124,9 @@ get_attribute_options(Oid attrelid, int attnum)
 	{
 		AttributeOpts *opts;
 
-		tp = SearchSysCache2(ATTNUM,
+		tp = SearchSysCache2(ATTPHYSNUM,
 							 ObjectIdGetDatum(attrelid),
-							 Int16GetDatum(attnum));
+							 Int16GetDatum(attphysnum));
 
 		/*
 		 * If we don't find a valid HeapTuple, it must mean someone has
@@ -140,7 +140,7 @@ get_attribute_options(Oid attrelid, int attnum)
 			Datum		datum;
 			bool		isNull;
 
-			datum = SysCacheGetAttr(ATTNUM,
+			datum = SysCacheGetAttr(ATTPHYSNUM,
 									tp,
 									Anum_pg_attribute_attoptions,
 									&isNull);
diff --git a/src/backend/utils/cache/catcache.c b/src/backend/utils/cache/catcache.c
index 6ae7c1f50b..9bf99c113b 100644
--- a/src/backend/utils/cache/catcache.c
+++ b/src/backend/utils/cache/catcache.c
@@ -1909,13 +1909,13 @@ CatCacheFreeKeys(TupleDesc tupdesc, int nkeys, int *attnos, Datum *keys)
 
 	for (i = 0; i < nkeys; i++)
 	{
-		int			attnum = attnos[i];
+		int			attphysnum = attnos[i];
 		Form_pg_attribute att;
 
 		/* system attribute are not supported in caches */
-		Assert(attnum > 0);
+		Assert(attphysnum > 0);
 
-		att = TupleDescAttr(tupdesc, attnum - 1);
+		att = TupleDescAttr(tupdesc, attphysnum - 1);
 
 		if (!att->attbyval)
 			pfree(DatumGetPointer(keys[i]));
@@ -1940,8 +1940,8 @@ CatCacheCopyKeys(TupleDesc tupdesc, int nkeys, int *attnos,
 
 	for (i = 0; i < nkeys; i++)
 	{
-		int			attnum = attnos[i];
-		Form_pg_attribute att = TupleDescAttr(tupdesc, attnum - 1);
+		int			attphysnum = attnos[i];
+		Form_pg_attribute att = TupleDescAttr(tupdesc, attphysnum - 1);
 		Datum		src = srckeys[i];
 		NameData	srcname;
 
diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index 1b7e11b93e..721fb194e7 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -822,12 +822,12 @@ get_opfamily_proc(Oid opfamily, Oid lefttype, Oid righttype, int16 procnum)
  * otherwise a not-intended-for-user-consumption error is thrown.
  */
 char *
-get_attname(Oid relid, AttrNumber attnum, bool missing_ok)
+get_attname(Oid relid, AttrNumber attphysnum, bool missing_ok)
 {
 	HeapTuple	tp;
 
-	tp = SearchSysCache2(ATTNUM,
-						 ObjectIdGetDatum(relid), Int16GetDatum(attnum));
+	tp = SearchSysCache2(ATTPHYSNUM,
+						 ObjectIdGetDatum(relid), Int16GetDatum(attphysnum));
 	if (HeapTupleIsValid(tp))
 	{
 		Form_pg_attribute att_tup = (Form_pg_attribute) GETSTRUCT(tp);
@@ -840,7 +840,7 @@ get_attname(Oid relid, AttrNumber attnum, bool missing_ok)
 
 	if (!missing_ok)
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
+			 attphysnum, relid);
 	return NULL;
 }
 
@@ -848,12 +848,12 @@ get_attname(Oid relid, AttrNumber attnum, bool missing_ok)
  * get_attnum
  *
  *		Given the relation id and the attribute name,
- *		return the "attnum" field from the attribute relation.
+ *		return the "attphysnum" field from the attribute relation.
  *
  *		Returns InvalidAttrNumber if the attr doesn't exist (or is dropped).
  */
 AttrNumber
-get_attnum(Oid relid, const char *attname)
+get_attphysnum(Oid relid, const char *attname)
 {
 	HeapTuple	tp;
 
@@ -863,7 +863,7 @@ get_attnum(Oid relid, const char *attname)
 		Form_pg_attribute att_tup = (Form_pg_attribute) GETSTRUCT(tp);
 		AttrNumber	result;
 
-		result = att_tup->attnum;
+		result = att_tup->attphysnum;
 		ReleaseSysCache(tp);
 		return result;
 	}
@@ -880,18 +880,18 @@ get_attnum(Oid relid, const char *attname)
  *		Errors if not found.
  */
 int
-get_attstattarget(Oid relid, AttrNumber attnum)
+get_attstattarget(Oid relid, AttrNumber attphysnum)
 {
 	HeapTuple	tp;
 	Form_pg_attribute att_tup;
 	int			result;
 
-	tp = SearchSysCache2(ATTNUM,
+	tp = SearchSysCache2(ATTPHYSNUM,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum));
+						 Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
+			 attphysnum, relid);
 	att_tup = (Form_pg_attribute) GETSTRUCT(tp);
 	result = att_tup->attstattarget;
 	ReleaseSysCache(tp);
@@ -910,18 +910,18 @@ get_attstattarget(Oid relid, AttrNumber attnum)
  *		Boolean test.
  */
 char
-get_attgenerated(Oid relid, AttrNumber attnum)
+get_attgenerated(Oid relid, AttrNumber attphysnum)
 {
 	HeapTuple	tp;
 	Form_pg_attribute att_tup;
 	char		result;
 
-	tp = SearchSysCache2(ATTNUM,
+	tp = SearchSysCache2(ATTPHYSNUM,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum));
+						 Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
+			 attphysnum, relid);
 	att_tup = (Form_pg_attribute) GETSTRUCT(tp);
 	result = att_tup->attgenerated;
 	ReleaseSysCache(tp);
@@ -935,13 +935,13 @@ get_attgenerated(Oid relid, AttrNumber attnum)
  *		return the attribute type OID.
  */
 Oid
-get_atttype(Oid relid, AttrNumber attnum)
+get_atttype(Oid relid, AttrNumber attphysnum)
 {
 	HeapTuple	tp;
 
-	tp = SearchSysCache2(ATTNUM,
+	tp = SearchSysCache2(ATTPHYSNUM,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum));
+						 Int16GetDatum(attphysnum));
 	if (HeapTupleIsValid(tp))
 	{
 		Form_pg_attribute att_tup = (Form_pg_attribute) GETSTRUCT(tp);
@@ -965,18 +965,18 @@ get_atttype(Oid relid, AttrNumber attnum)
  * raises an error if it can't obtain the information.
  */
 void
-get_atttypetypmodcoll(Oid relid, AttrNumber attnum,
+get_atttypetypmodcoll(Oid relid, AttrNumber attphysnum,
 					  Oid *typid, int32 *typmod, Oid *collid)
 {
 	HeapTuple	tp;
 	Form_pg_attribute att_tup;
 
-	tp = SearchSysCache2(ATTNUM,
+	tp = SearchSysCache2(ATTPHYSNUM,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum));
+						 Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
+			 attphysnum, relid);
 	att_tup = (Form_pg_attribute) GETSTRUCT(tp);
 
 	*typid = att_tup->atttypid;
@@ -992,20 +992,20 @@ get_atttypetypmodcoll(Oid relid, AttrNumber attnum,
  *		return the attribute options text[] datum, if any.
  */
 Datum
-get_attoptions(Oid relid, int16 attnum)
+get_attoptions(Oid relid, int16 attphysnum)
 {
 	HeapTuple	tuple;
 	Datum		attopts;
 	Datum		result;
 	bool		isnull;
 
-	tuple = SearchSysCache2(ATTNUM,
+	tuple = SearchSysCache2(ATTPHYSNUM,
 							ObjectIdGetDatum(relid),
-							Int16GetDatum(attnum));
+							Int16GetDatum(attphysnum));
 
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
+			 attphysnum, relid);
 
 	attopts = SysCacheGetAttr(ATTNAME, tuple, Anum_pg_attribute_attoptions,
 							  &isnull);
@@ -3112,20 +3112,20 @@ getSubscriptingRoutines(Oid typid, Oid *typelemp)
  * plug-ins to control the result.
  */
 int32
-get_attavgwidth(Oid relid, AttrNumber attnum)
+get_attavgwidth(Oid relid, AttrNumber attphysnum)
 {
 	HeapTuple	tp;
 	int32		stawidth;
 
 	if (get_attavgwidth_hook)
 	{
-		stawidth = (*get_attavgwidth_hook) (relid, attnum);
+		stawidth = (*get_attavgwidth_hook) (relid, attphysnum);
 		if (stawidth > 0)
 			return stawidth;
 	}
 	tp = SearchSysCache3(STATRELATTINH,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum),
+						 Int16GetDatum(attphysnum),
 						 BoolGetDatum(false));
 	if (HeapTupleIsValid(tp))
 	{
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index 0e8fda97f8..8a98060956 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -537,7 +537,7 @@ RelationBuildTupleDesc(Relation relation)
 	constr->has_generated_stored = false;
 
 	/*
-	 * Form a scan key that selects only user attributes (attnum > 0).
+	 * Form a scan key that selects only user attributes (attphysnum > 0).
 	 * (Eliminating system attribute rows at the index level is lots faster
 	 * than fetching them.)
 	 */
@@ -546,7 +546,7 @@ RelationBuildTupleDesc(Relation relation)
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(RelationGetRelid(relation)));
 	ScanKeyInit(&skey[1],
-				Anum_pg_attribute_attnum,
+				Anum_pg_attribute_attphysnum,
 				BTGreaterStrategyNumber, F_INT2GT,
 				Int16GetDatum(0));
 
@@ -557,7 +557,7 @@ RelationBuildTupleDesc(Relation relation)
 	 */
 	pg_attribute_desc = table_open(AttributeRelationId, AccessShareLock);
 	pg_attribute_scan = systable_beginscan(pg_attribute_desc,
-										   AttributeRelidNumIndexId,
+										   AttributeRelidPhysNumIndexId,
 										   criticalRelcachesBuilt,
 										   NULL,
 										   2, skey);
@@ -570,16 +570,16 @@ RelationBuildTupleDesc(Relation relation)
 	while (HeapTupleIsValid(pg_attribute_tuple = systable_getnext(pg_attribute_scan)))
 	{
 		Form_pg_attribute attp;
-		int			attnum;
+		int			attphysnum;
 
 		attp = (Form_pg_attribute) GETSTRUCT(pg_attribute_tuple);
 
-		attnum = attp->attnum;
-		if (attnum <= 0 || attnum > RelationGetNumberOfAttributes(relation))
+		attphysnum = attp->attphysnum;
+		if (attphysnum <= 0 || attphysnum > RelationGetNumberOfAttributes(relation))
 			elog(ERROR, "invalid attribute number %d for relation \"%s\"",
-				 attp->attnum, RelationGetRelationName(relation));
+				 attp->attphysnum, RelationGetRelationName(relation));
 
-		memcpy(TupleDescAttr(relation->rd_att, attnum - 1),
+		memcpy(TupleDescAttr(relation->rd_att, attphysnum - 1),
 			   attp,
 			   ATTRIBUTE_FIXED_PART_SIZE);
 
@@ -628,18 +628,18 @@ RelationBuildTupleDesc(Relation relation)
 				if (attp->attbyval)
 				{
 					/* for copy by val just copy the datum direct */
-					attrmiss[attnum - 1].am_value = missval;
+					attrmiss[attphysnum - 1].am_value = missval;
 				}
 				else
 				{
 					/* otherwise copy in the correct context */
 					oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
-					attrmiss[attnum - 1].am_value = datumCopy(missval,
+					attrmiss[attphysnum - 1].am_value = datumCopy(missval,
 															  attp->attbyval,
 															  attp->attlen);
 					MemoryContextSwitchTo(oldcxt);
 				}
-				attrmiss[attnum - 1].am_present = true;
+				attrmiss[attphysnum - 1].am_present = true;
 			}
 		}
 		need--;
@@ -4046,7 +4046,7 @@ RelationCacheInitializePhase3(void)
 	{
 		load_critical_index(ClassOidIndexId,
 							RelationRelationId);
-		load_critical_index(AttributeRelidNumIndexId,
+		load_critical_index(AttributeRelidPhysNumIndexId,
 							AttributeRelationId);
 		load_critical_index(IndexRelidIndexId,
 							IndexRelationId);
@@ -5708,21 +5708,21 @@ RelationGetIndexRawAttOptions(Relation indexrel)
 	Oid			indexrelid = RelationGetRelid(indexrel);
 	int16		natts = RelationGetNumberOfAttributes(indexrel);
 	Datum	   *options = NULL;
-	int16		attnum;
+	int16		attphysnum;
 
-	for (attnum = 1; attnum <= natts; attnum++)
+	for (attphysnum = 1; attphysnum <= natts; attphysnum++)
 	{
 		if (indexrel->rd_indam->amoptsprocnum == 0)
 			continue;
 
-		if (!OidIsValid(index_getprocid(indexrel, attnum,
+		if (!OidIsValid(index_getprocid(indexrel, attphysnum,
 										indexrel->rd_indam->amoptsprocnum)))
 			continue;
 
 		if (!options)
 			options = palloc0(sizeof(Datum) * natts);
 
-		options[attnum - 1] = get_attoptions(indexrelid, attnum);
+		options[attphysnum - 1] = get_attoptions(indexrelid, attphysnum);
 	}
 
 	return options;
@@ -5767,7 +5767,7 @@ RelationGetIndexAttOptions(Relation relation, bool copy)
 
 	for (i = 0; i < natts; i++)
 	{
-		if (criticalRelcachesBuilt && relid != AttributeRelidNumIndexId)
+		if (criticalRelcachesBuilt && relid != AttributeRelidPhysNumIndexId)
 		{
 			Datum		attoptions = get_attoptions(relid, i + 1);
 
@@ -5827,16 +5827,16 @@ errtable(Relation rel)
  * easier and less error-prone than getting the column name for themselves.
  */
 int
-errtablecol(Relation rel, int attnum)
+errtablecol(Relation rel, int attphysnum)
 {
 	TupleDesc	reldesc = RelationGetDescr(rel);
 	const char *colname;
 
 	/* Use reldesc if it's a user attribute, else consult the catalogs */
-	if (attnum > 0 && attnum <= reldesc->natts)
-		colname = NameStr(TupleDescAttr(reldesc, attnum - 1)->attname);
+	if (attphysnum > 0 && attphysnum <= reldesc->natts)
+		colname = NameStr(TupleDescAttr(reldesc, attphysnum - 1)->attname);
 	else
-		colname = get_attname(RelationGetRelid(rel), attnum, false);
+		colname = get_attname(RelationGetRelid(rel), attphysnum, false);
 
 	return errtablecolname(rel, colname);
 }
